use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkRayTracingPipelineInterfaceCreateInfoKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub maxPipelineRayPayloadSize: u32,
    pub maxPipelineRayHitAttributeSize: u32,
}

impl VkRayTracingPipelineInterfaceCreateInfoKHR {
    pub fn new(
        max_pipeline_ray_payload_size: u32,
        max_pipeline_ray_hit_attribute_size: u32,
    ) -> Self {
        VkRayTracingPipelineInterfaceCreateInfoKHR {
            sType: VK_STRUCTURE_TYPE_RAY_TRACING_PIPELINE_INTERFACE_CREATE_INFO_KHR,
            pNext: ptr::null(),
            maxPipelineRayPayloadSize: max_pipeline_ray_payload_size,
            maxPipelineRayHitAttributeSize: max_pipeline_ray_hit_attribute_size,
        }
    }
}
